// This sketch requires the HC-05 module to start in the AT command mode.
// 1. Disconnect the VCC (power) line from the HC-05 and reconnect it while holding down the button.
// 2. The HC-05 LED should blink on and off at about 2 second intervals. Otherwise, try Step 1 again.
// 3. Upload this sketch.
// 4. Open the serial monitor (CTRL+SHIFT+M) and choose "Both NL & CR" & "9600 baud".
// 5. Type "AT" and send. If "OK" returns, the connection is fine.

#include <SoftwareSerial.h>

SoftwareSerial hc05(2, 3);  // Rx, Tx
// Connect Arduino pin 2 (RX) to the HC-05 TX.
// Connect Arduino pin 3 (TX) to the HC-05 RX through a voltage divider.
// For more information about the voltage divider, see the following link.
// https://electronics.stackexchange.com/questions/280500/why-do-you-have-to-use-a-voltage-divider-with-hc-05-bluetooth-module-arduino

long hardserial_baudrate = 9600;   // connection speed between PC and Arduino
long softserial_baudrate = 38400;  // connection speed between Arduino and HC-05 in the AT command mode

void setup() {
  Serial.begin(hardserial_baudrate);  // between PC and Arduino
  hc05.begin(softserial_baudrate);      // between Arduino and HC-05

  Serial.println("Enter AT commands:");
}

void loop() {
  if (hc05.available()) Serial.write(hc05.read());
  if (Serial.available()) hc05.write(Serial.read());
}
